<template>
    <v-card-title class="mb-1">
        <div class="grid gap-x-6 lg:grid-cols-2">
            <slot name="label"></slot>
            <v-card-actions class="d-flex align-end flex-column">
                <div class="d-flex flex-row-reverse bg-surface">
                    <div class="flex flex-col items-end ma-1">
                        <v-btn size="small" :icon="btnClass" @click="emitExpandChange" variant="flat"></v-btn>
                    </div>
                    <div class="flex flex-col items-end ma-1" v-if="props.removable">
                        <ButtonDelete :visible="props.removable" @click="emitRemoveCard"></ButtonDelete>
                    </div>
                </div>
            </v-card-actions>
        </div>
    </v-card-title>
</template>

<script setup lang="ts">
import { ref, defineProps, defineEmits, onMounted, getCurrentInstance, watch } from 'vue';

//Components
import ButtonDelete from '@/components/button/ButtonDelete.vue';

const emit = defineEmits(['change:expand', 'remove:section']);
const currentIndex = getCurrentInstance()?.vnode.key;

const expandedData = ref(true); // temp
const btnClass = ref('');

const props = defineProps({
    title: {
        type: String,
        default: '',
    },
    removable: {
        type: Boolean,
        default: false,
    },
    expanded: {
        type: Boolean,
        default: true,
    },
});

watch(props, (p) => {
    p.expanded ? expand() : collapse();
});

const changeClass = () => {
    btnClass.value = expandedData.value ? 'mdi-chevron-up' : 'mdi-chevron-down';
};

const changeValue = () => {
    expandedData.value = !expandedData.value;
};

const emitExpandChange = () => {
    changeValue();
    changeClass();

    emit('change:expand', expandedData);
};

const expand = () => {
    expandedData.value = true;
    btnClass.value = 'mdi-chevron-up';
};

const collapse = () => {
    expandedData.value = false;
    btnClass.value = 'mdi-chevron-down';
};

const emitRemoveCard = () => {
    emit('remove:section', currentIndex);
};

onMounted(async () => {
    expandedData.value = true;
    btnClass.value = 'mdi-chevron-up';
});
</script>
